/**
 * Copyright (C) 2010 Michael Mosmann <michael@mosmann.de>
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *         http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package de.flapdoodle.mongoom.mapping.types;

import java.lang.reflect.Type;
import java.util.List;
import java.util.Set;

import de.flapdoodle.mongoom.mapping.ITransformation;
import de.flapdoodle.mongoom.mapping.ITypeVisitor;


public class SetVisitor<T,M> extends AbstractCollectionVisitor<Set<T>,M> implements ITypeVisitor<Set<T>, List<M>>{

	protected ITransformation<Set<T>, List<M>> transformation(Type parameterizedClass, ITransformation transformation) {
		return new SetTransformation<T,M>((Class<T>) parameterizedClass,transformation);
	}
}
